##' Analysis of Multivariate Events 
##' 
##' Implementation of various statistical models for multivariate
##' event history data. Including multivariate cumulative incidence models,
##' and bivariate random effects probit models (Liability models) 
##'
##' @name mets-package
##' @docType package
##' @author Klaus K. Holst and Thomas Scheike
##' @useDynLib mets
##' @import stats lava
##' @keywords package
##' @examples
##' 
##' ## To appear
##' 
NULL

##' np data set
##'
##' @name np
##' @docType data
##' @keywords data
NULL

##' Migraine data
##'
##' @name migr
##' @docType data
##' @keywords data
NULL


##' Menarche data set (sim)
##'
##' @name mena
##' @docType data
##' @keywords data
NULL

##' Multivariate Cumulative Incidence Function example data set
##'
##' @name multcif
##' @docType data
##' @keywords data
NULL

##' Stutter data set
##'
##' @name twinstut
##' @docType data
##' @keywords data
NULL

##' BMI data set
##'
##' @name twinbmi
##' @docType data
##' @keywords data
NULL

##' Prostate data set (sim)
##'
##' @name prt
##' @docType data
##' @keywords data
NULL

##' For internal use
##' 
##' @title For internal use
##' @name npc
##' @rdname internal
##' @author Klaus K. Holst
##' @keywords utilities
##' @export
##' @aliases plotcr npc nonparcuminc simnordic corsim.prostate
##' alpha2kendall alpha2spear coefmat piecewise.twostage surv.boxarea
##' cluster.index familycluster.index faster.reshape piecewise.data
##' simBinPlack simBinFam simSurvFam simCox sim 
NULL

